=== debian/watch ===
version=4
opts=repacksuffix=+dfsg,dversionmangle=s/\+dfsg// \
https://sf.net/codeblocks/codeblocks[_\-]([\d\.]*)\.(?:tgz|tbz2|txz|tar\.(?:gz|bz2|xz))
